'use strict';

/**
 * Module dependencies
 */

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var JSONPointer = require('./JSONPointer');

/**
 * JSONReference
 */

var JSONReference = function () {

  /**
   * Constructor
   *
   * @param {string|Object} reference
   */
  function JSONReference(reference) {
    _classCallCheck(this, JSONReference);

    var $ref = void 0;

    if (typeof reference === 'string') {
      $ref = reference;
    }
    if ((typeof reference === 'undefined' ? 'undefined' : _typeof(reference)) === 'object') {
      $ref = reference['$ref'];
    }

    if ($ref === undefined || typeof $ref !== 'string') {
      throw new Error('Invalid reference');
    }

    // parse ref as url, then
    // should this actually extend a url "class"? (node url module)

    this.$ref = $ref;
  }

  /**
   * Resolve
   *
   * @param {Object} rootSchema
   * @returns {Object}
   */


  _createClass(JSONReference, [{
    key: 'resolve',
    value: function resolve(rootSchema) {
      var $ref = this.$ref;

      // 1. canonical dereferencing
      // 2. inline dereferencing

      // simplest case where ref is just a JSON Pointer

      var pointer = new JSONPointer($ref);

      // what about "definitions"?
      var subschema = pointer.get(rootSchema);

      return subschema;
    }
  }]);

  return JSONReference;
}();

/**
 * Export
 */


module.exports = JSONReference;