'use strict'

/**
 * Module dependencies
 */
const JSONPointer = require('./JSONPointer')

/**
 * JSONReference
 */
class JSONReference {

  /**
   * Constructor
   *
   * @param {string|Object} reference
   */
  constructor (reference) {
    let $ref

    if (typeof reference === 'string') { $ref = reference }
    if (typeof reference === 'object') { $ref = reference['$ref'] }

    if ($ref === undefined || typeof $ref !== 'string') {
      throw new Error('Invalid reference')
    }

    // parse ref as url, then
    // should this actually extend a url "class"? (node url module)

    this.$ref = $ref
  }

  /**
   * Resolve
   *
   * @param {Object} rootSchema
   * @returns {Object}
   */
  resolve (rootSchema) {
    let {$ref} = this

    // 1. canonical dereferencing
    // 2. inline dereferencing

    // simplest case where ref is just a JSON Pointer
    let pointer = new JSONPointer($ref)

    // what about "definitions"?
    let subschema = pointer.get(rootSchema)


    return subschema
  }
}

/**
 * Export
 */
module.exports = JSONReference
